# lbaselib.c File Reference

`#include <ctype.h>`
`#include <stdio.h>`
`#include <stdlib.h>`
`#include <string.h>`
`#include "lua.h"`
`#include "lauxlib.h"`
`#include "lualib.h"`

## Defines
#define | lbaselib_c
#define | LUA_LIB
#define | CO_RUN 0
#define | CO_SUS 1
#define | CO_NOR 2
#define | CO_DEAD 3
## Functions
static int | luaB_print (lua_State *L)
static int | luaB_tonumber (lua_State *L)
static int | luaB_error (lua_State *L)
static int | luaB_getmetatable (lua_State *L)
static int | luaB_setmetatable (lua_State *L)
static void | getfunc (lua_State *L, int opt)
static int | luaB_getfenv (lua_State *L)
static int | luaB_setfenv (lua_State *L)
static int | luaB_rawequal (lua_State *L)
static int | luaB_rawget (lua_State *L)
static int | luaB_rawset (lua_State *L)
static int | luaB_gcinfo (lua_State *L)
static int | luaB_collectgarbage (lua_State *L)
static int | luaB_type (lua_State *L)
static int | luaB_next (lua_State *L)
static int | luaB_pairs (lua_State *L)
static int | ipairsaux (lua_State *L)
static int | luaB_ipairs (lua_State *L)
static int | load_aux (lua_State *L, int status)
static int | luaB_loadstring (lua_State *L)
static int | luaB_loadfile (lua_State *L)
static const char * | generic_reader (lua_State *L, void *ud, size_t *size)
static int | luaB_load (lua_State *L)
static int | luaB_dofile (lua_State *L)
static int | luaB_assert (lua_State *L)
static int | luaB_unpack (lua_State *L)
static int | luaB_select (lua_State *L)
static int | luaB_pcall (lua_State *L)
static int | luaB_xpcall (lua_State *L)
static int | luaB_tostring (lua_State *L)
static int | luaB_newproxy (lua_State *L)
static int | costatus (lua_State *L, lua_State *co)
static int | luaB_costatus (lua_State *L)
static int | auxresume (lua_State *L, lua_State *co, int narg)
static int | luaB_coresume (lua_State *L)
static int | luaB_auxwrap (lua_State *L)
static int | luaB_cocreate (lua_State *L)
static int | luaB_cowrap (lua_State *L)
static int | luaB_yield (lua_State *L)
static int | luaB_corunning (lua_State *L)
static void | auxopen (lua_State *L, const char *name, lua_CFunction f, lua_CFunction u)
static void | base_open (lua_State *L)
LUALIB_API int | luaopen_base (lua_State *L)
## Variables
static const luaL_Reg | base_funcs []
static const char *const | statnames []
static const luaL_Reg | co_funcs []

## Define Documentation

#define CO_DEAD 3

#define CO_NOR 2

#define CO_RUN 0

#define CO_SUS 1

#define lbaselib_c

#define LUA_LIB

## Function Documentation

static void auxopen | ( | lua_State * | L,
|  | const char * | name,
|  | lua_CFunction | f,
|  | lua_CFunction | u |
| ) |  |  | `[static]`

static int auxresume | ( | lua_State * | L,
|  | lua_State * | co,
|  | int | narg |
| ) |  |  | `[static]`

static void base_open | ( | lua_State * | L | ) | `[static]`

static int costatus | ( | lua_State * | L,
|  | lua_State * | co |
| ) |  |  | `[static]`

static const char* generic_reader | ( | lua_State * | L,
|  | void * | ud,
|  | size_t * | size |
| ) |  |  | `[static]`

static void getfunc | ( | lua_State * | L,
|  | int | opt |
| ) |  |  | `[static]`

static int ipairsaux | ( | lua_State * | L | ) | `[static]`

static int load_aux | ( | lua_State * | L,
|  | int | status |
| ) |  |  | `[static]`

static int luaB_assert | ( | lua_State * | L | ) | `[static]`

static int luaB_auxwrap | ( | lua_State * | L | ) | `[static]`

static int luaB_cocreate | ( | lua_State * | L | ) | `[static]`

static int luaB_collectgarbage | ( | lua_State * | L | ) | `[static]`

static int luaB_coresume | ( | lua_State * | L | ) | `[static]`

static int luaB_corunning | ( | lua_State * | L | ) | `[static]`

static int luaB_costatus | ( | lua_State * | L | ) | `[static]`

static int luaB_cowrap | ( | lua_State * | L | ) | `[static]`

static int luaB_dofile | ( | lua_State * | L | ) | `[static]`

static int luaB_error | ( | lua_State * | L | ) | `[static]`

static int luaB_gcinfo | ( | lua_State * | L | ) | `[static]`

static int luaB_getfenv | ( | lua_State * | L | ) | `[static]`

static int luaB_getmetatable | ( | lua_State * | L | ) | `[static]`

static int luaB_ipairs | ( | lua_State * | L | ) | `[static]`

static int luaB_load | ( | lua_State * | L | ) | `[static]`

static int luaB_loadfile | ( | lua_State * | L | ) | `[static]`

static int luaB_loadstring | ( | lua_State * | L | ) | `[static]`

static int luaB_newproxy | ( | lua_State * | L | ) | `[static]`

static int luaB_next | ( | lua_State * | L | ) | `[static]`

static int luaB_pairs | ( | lua_State * | L | ) | `[static]`

static int luaB_pcall | ( | lua_State * | L | ) | `[static]`

static int luaB_print | ( | lua_State * | L | ) | `[static]`

static int luaB_rawequal | ( | lua_State * | L | ) | `[static]`

static int luaB_rawget | ( | lua_State * | L | ) | `[static]`

static int luaB_rawset | ( | lua_State * | L | ) | `[static]`

static int luaB_select | ( | lua_State * | L | ) | `[static]`

static int luaB_setfenv | ( | lua_State * | L | ) | `[static]`

static int luaB_setmetatable | ( | lua_State * | L | ) | `[static]`

static int luaB_tonumber | ( | lua_State * | L | ) | `[static]`

static int luaB_tostring | ( | lua_State * | L | ) | `[static]`

static int luaB_type | ( | lua_State * | L | ) | `[static]`

static int luaB_unpack | ( | lua_State * | L | ) | `[static]`

static int luaB_xpcall | ( | lua_State * | L | ) | `[static]`

static int luaB_yield | ( | lua_State * | L | ) | `[static]`

LUALIB_API int luaopen_base | ( | lua_State * | L | ) |

## Variable Documentation

const luaL_Reg base_funcs[]`[static]`

Initial value:

     {
      {"assert", luaB_assert},
      {"collectgarbage", luaB_collectgarbage},
      {"dofile", luaB_dofile},
      {"error", luaB_error},
      {"gcinfo", luaB_gcinfo},
      {"getfenv", luaB_getfenv},
      {"getmetatable", luaB_getmetatable},
      {"loadfile", luaB_loadfile},
      {"load", luaB_load},
      {"loadstring", luaB_loadstring},
      {"next", luaB_next},
      {"pcall", luaB_pcall},
      {"print", luaB_print},
      {"rawequal", luaB_rawequal},
      {"rawget", luaB_rawget},
      {"rawset", luaB_rawset},
      {"select", luaB_select},
      {"setfenv", luaB_setfenv},
      {"setmetatable", luaB_setmetatable},
      {"tonumber", luaB_tonumber},
      {"tostring", luaB_tostring},
      {"type", luaB_type},
      {"unpack", luaB_unpack},
      {"xpcall", luaB_xpcall},
      {NULL, NULL}
    }

const luaL_Reg co_funcs[]`[static]`

Initial value:

     {
      {"create", luaB_cocreate},
      {"resume", luaB_coresume},
      {"running", luaB_corunning},
      {"status", luaB_costatus},
      {"wrap", luaB_cowrap},
      {"yield", luaB_yield},
      {NULL, NULL}
    }

const char* const statnames[]`[static]`

Initial value:

        {"running", "suspended", "normal", "dead"}